=== modified file 'drizzled/foreign_key.h'
--- drizzled/foreign_key.h	2011-07-25 14:24:19 +0000
+++ drizzled/foreign_key.h	2011-10-18 11:01:40 +0000
@@ -40,7 +40,7 @@
     message::Table::ForeignKeyConstraint::ForeignKeyMatchOption match_opt_arg);
 
 
-class Foreign_key: public Key 
+class Foreign_key : public Key 
 {
 public:
   Table_ident *ref_table;
@@ -50,7 +50,7 @@
   message::Table::ForeignKeyConstraint::ForeignKeyOption update_opt;
   message::Table::ForeignKeyConstraint::ForeignKeyMatchOption match_opt;
 
-  Foreign_key(const lex_string_t &name_arg,
+  Foreign_key(lex_string_t name_arg,
               List<Key_part_spec> &cols,
               Table_ident *table,
               List<Key_part_spec> &ref_cols,
@@ -78,4 +78,3 @@
 };
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/function/get_system_var.h'
--- drizzled/function/get_system_var.h	2011-07-25 14:24:19 +0000
+++ drizzled/function/get_system_var.h	2011-10-18 12:33:04 +0000
@@ -29,7 +29,7 @@
 
 /* A system variable */
 
-class Item_func_get_system_var :public Item_func
+class Item_func_get_system_var : public Item_func
 {
   sys_var *var;
   sql_var_t var_type;

=== modified file 'drizzled/function/get_user_var.h'
--- drizzled/function/get_user_var.h	2011-07-25 14:24:19 +0000
+++ drizzled/function/get_user_var.h	2011-10-18 12:15:09 +0000
@@ -31,15 +31,15 @@
   Session &session;
 
 public:
-  lex_string_t name; // keep it public
-  Item_func_get_user_var(Session &session_arg, lex_string_t a):
+  str_ref name; // keep it public
+  Item_func_get_user_var(Session &session_arg, str_ref a) :
     Item_func(),
     m_cached_result_type(STRING_RESULT),
     session(session_arg),
     name(a)
   {}
   enum Functype functype() const { return GUSERVAR_FUNC; }
-  lex_string_t get_name() { return name; }
+  str_ref get_name() { return name; }
   double val_real();
   int64_t val_int();
   type::Decimal *val_decimal(type::Decimal*);

=== modified file 'drizzled/function/set_user_var.cc'
--- drizzled/function/set_user_var.cc	2011-10-06 18:18:31 +0000
+++ drizzled/function/set_user_var.cc	2011-10-18 11:48:44 +0000
@@ -99,7 +99,7 @@
 
 
 void
-Item_func_set_user_var::update_hash(void *ptr, uint32_t length,
+Item_func_set_user_var::update_hash(data_ref data,
                                     Item_result res_type,
                                     const charset_info_st * const cs, Derivation dv,
                                     bool unsigned_arg)
@@ -110,7 +110,7 @@
   */
   if ((null_value= args[0]->null_value) && null_item)
     res_type= entry->type;                      // Don't change type of item
-  entry->update_hash((null_value= args[0]->null_value), ptr, length, res_type, cs, dv, unsigned_arg);
+  entry->update_hash((null_value= args[0]->null_value), data, res_type, cs, dv, unsigned_arg);
 }
 
 /**
@@ -193,47 +193,37 @@
   switch (cached_result_type) {
   case REAL_RESULT:
     {
-      update_hash((void*) &save_result.vreal,sizeof(save_result.vreal),
-                       REAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
+      update_hash(data_ref(&save_result.vreal, sizeof(save_result.vreal)), REAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
       break;
     }
 
   case INT_RESULT:
     {
-      update_hash((void*) &save_result.vint, sizeof(save_result.vint),
-                       INT_RESULT, &my_charset_bin, DERIVATION_IMPLICIT,
-                       unsigned_flag);
+      update_hash(data_ref(&save_result.vint, sizeof(save_result.vint)), INT_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, unsigned_flag);
       break;
     }
 
   case STRING_RESULT:
     {
       if (!save_result.vstr)                                      // Null value
-        update_hash((void*) 0, 0, STRING_RESULT, &my_charset_bin,
-                         DERIVATION_IMPLICIT, 0);
+        update_hash(data_ref(), STRING_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
       else
-        update_hash((void*) save_result.vstr->ptr(),
-                         save_result.vstr->length(), STRING_RESULT,
-                         save_result.vstr->charset(),
-                         DERIVATION_IMPLICIT, 0);
+        update_hash(*save_result.vstr, STRING_RESULT, save_result.vstr->charset(), DERIVATION_IMPLICIT, 0);
       break;
     }
 
   case DECIMAL_RESULT:
     {
       if (!save_result.vdec)                                      // Null value
-        update_hash((void*) 0, 0, DECIMAL_RESULT, &my_charset_bin,
-                         DERIVATION_IMPLICIT, 0);
+        update_hash(data_ref(), DECIMAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
       else
-        update_hash((void*) save_result.vdec,
-                         sizeof(type::Decimal), DECIMAL_RESULT,
-                         &my_charset_bin, DERIVATION_IMPLICIT, 0);
+        update_hash(data_ref(save_result.vdec, sizeof(type::Decimal)), DECIMAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
       break;
     }
 
   case ROW_RESULT:
     // This case should never be chosen
-    assert(0);
+    assert(false);
     break;
   }
 }

=== modified file 'drizzled/function/set_user_var.h'
--- drizzled/function/set_user_var.h	2011-07-25 14:24:19 +0000
+++ drizzled/function/set_user_var.h	2011-10-18 12:33:04 +0000
@@ -25,7 +25,7 @@
 
 /* Handling of user definable variables */
 
-class Item_func_set_user_var :public Item_func
+class Item_func_set_user_var : public Item_func
 {
   enum Item_result cached_result_type;
   user_var_entry *entry;
@@ -42,11 +42,11 @@
   } save_result;
 
 public:
-  lex_string_t name; // keep it public
-  Item_func_set_user_var(lex_string_t a,Item *b)
-    :Item_func(b), cached_result_type(INT_RESULT), name(a)
+  str_ref name; // keep it public
+  Item_func_set_user_var(str_ref a,Item *b) :
+    Item_func(b), cached_result_type(INT_RESULT), name(a)
   {}
-  enum Functype functype() const { return SUSERVAR_FUNC; }
+  Functype functype() const { return SUSERVAR_FUNC; }
   double val_real();
   int64_t val_int();
   String *val_str(String *str);
@@ -55,8 +55,7 @@
   int64_t val_int_result();
   String *str_result(String *str);
   type::Decimal *val_decimal_result(type::Decimal *);
-  void update_hash(void *ptr, uint32_t length, enum Item_result type,
-  		   const charset_info_st * const cs, Derivation dv, bool unsigned_arg);
+  void update_hash(data_ref, Item_result type, const charset_info_st* cs, Derivation dv, bool unsigned_arg);
   void send(plugin::Client *client, String *str_arg);
   void make_field(SendField *tmp_field);
   bool check(bool use_result_field);

=== modified file 'drizzled/function/user_var_as_out_param.cc'
--- drizzled/function/user_var_as_out_param.cc	2011-10-06 18:18:31 +0000
+++ drizzled/function/user_var_as_out_param.cc	2011-10-18 11:48:44 +0000
@@ -44,18 +44,15 @@
   return false;
 }
 
-void Item_user_var_as_out_param::set_null_value(const charset_info_st * const cs)
+void Item_user_var_as_out_param::set_null_value(const charset_info_st* cs)
 {
-  entry->update_hash(true, 0, 0, STRING_RESULT, cs,
-                     DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
+  entry->update_hash(true, data_ref(), STRING_RESULT, cs, DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
 }
 
 
-void Item_user_var_as_out_param::set_value(const char *str, uint32_t length,
-                                           const charset_info_st * const cs)
+void Item_user_var_as_out_param::set_value(str_ref str, const charset_info_st* cs)
 {
-  entry->update_hash(false, (void*)str, length, STRING_RESULT, cs,
-                DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
+  entry->update_hash(false, str, STRING_RESULT, cs, DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
 }
 
 double Item_user_var_as_out_param::val_real()

=== modified file 'drizzled/function/user_var_as_out_param.h'
--- drizzled/function/user_var_as_out_param.h	2011-07-25 14:24:19 +0000
+++ drizzled/function/user_var_as_out_param.h	2011-10-18 11:01:40 +0000
@@ -21,8 +21,7 @@
 
 #include <drizzled/function/func.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 /*
   This item represents user variable used as out parameter (e.g in LOAD DATA),
@@ -33,24 +32,23 @@
   in List<Item> and desire to place this code somewhere near other functions
   working with user variables.
 */
-class Item_user_var_as_out_param :public Item
+class Item_user_var_as_out_param : public Item
 {
-  lex_string_t name;
+  str_ref name;
   user_var_entry *entry;
 public:
-  Item_user_var_as_out_param(lex_string_t a) : name(a) {}
+  Item_user_var_as_out_param(str_ref a) : name(a) {}
   /* We should return something different from FIELD_ITEM here */
-  enum Type type() const { return STRING_ITEM;}
+  Type type() const { return STRING_ITEM;}
   double val_real();
   int64_t val_int();
-  String *val_str(String *str);
+  String *val_str(String*);
   type::Decimal *val_decimal(type::Decimal *decimal_buffer);
   /* fix_fields() binds variable name with its entry structure */
-  bool fix_fields(Session *session, Item **ref);
-  virtual void print(String *str);
-  void set_null_value(const charset_info_st * const cs);
-  void set_value(const char *str, uint32_t length, const charset_info_st * const cs);
+  bool fix_fields(Session*, Item **ref);
+  virtual void print(String*);
+  void set_null_value(const charset_info_st*);
+  void set_value(str_ref, const charset_info_st*);
 };
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/identifier.h'
--- drizzled/identifier.h	2011-04-04 21:37:55 +0000
+++ drizzled/identifier.h	2011-10-18 13:52:19 +0000
@@ -26,7 +26,7 @@
 
 namespace drizzled {
 
-class DRIZZLED_API Identifier 
+class DRIZZLED_API Identifier
 {
 public:
   virtual ~Identifier()

=== modified file 'drizzled/identifier/constants/schema.cc'
--- drizzled/identifier/constants/schema.cc	2011-07-05 11:15:32 +0000
+++ drizzled/identifier/constants/schema.cc	2011-10-18 13:52:19 +0000
@@ -19,7 +19,6 @@
  */
 
 #include <config.h>
-
 #include <drizzled/identifier.h>
 
 namespace drizzled {
@@ -30,40 +29,39 @@
 class Schema : public identifier::Schema
 {
 public:
-  Schema(const std::string &name) :
-    identifier::Schema(name)
-  {
-    _path= boost::to_lower_copy(name);
-  }
-
-  const std::string &getPath() const
-  {
-    return _path;
-  }
-
-  inline bool isSystem() const
+  Schema(const char* name) :
+    identifier::Schema(str_ref(name)),
+    path_(boost::to_lower_copy(getSchemaName()))
+  {
+  }
+
+  const std::string& getPath() const
+  {
+    return path_;
+  }
+
+  bool isSystem() const
   {
     return true;
   }
 
 private:
-  std::string _path;
+  std::string path_;
 };
 
 } /* namespace constants */
 
-const identifier::Schema& data_dictionary()
+static constants::Schema g_dd= "DATA_DICTIONARY";
+static constants::Schema g_is= "INFORMATION_SCHEMA";
+
+const Schema& data_dictionary()
 {
-  static drizzled::identifier::Schema _tmp("DATA_DICTIONARY");
-
-  return _tmp;
+  return g_dd;
 }
 
-const identifier::Schema& information_schema()
+const Schema& information_schema()
 {
-  static drizzled::identifier::Schema _tmp("INFORMATION_SCHEMA");
-
-  return _tmp;
+  return g_is;
 }
 
 } /* namespace identifier */

=== modified file 'drizzled/identifier/constants/schema.h'
--- drizzled/identifier/constants/schema.h	2011-03-23 23:44:48 +0000
+++ drizzled/identifier/constants/schema.h	2011-10-18 13:52:19 +0000
@@ -23,13 +23,12 @@
 namespace drizzled {
 namespace identifier {
 
-const identifier::Schema& data_dictionary();
-const identifier::Schema& information_schema();
-const identifier::Schema& system_schema();
+const Schema& data_dictionary();
+const Schema& information_schema();
+const Schema& system_schema();
 
 } /* namespace identifier */
 } /* namespace drizzled */
 
 #define DATA_DICTIONARY_IDENTIFIER drizzled::identifier::data_dictionary()
 #define INFORMATION_SCHEMA_IDENTIFIER drizzled::identifier::information_schema()
-

=== modified file 'drizzled/identifier/schema.cc'
--- drizzled/identifier/schema.cc	2011-07-07 13:09:02 +0000
+++ drizzled/identifier/schema.cc	2011-10-18 13:52:19 +0000
@@ -41,8 +41,8 @@
 namespace drizzled {
 namespace identifier {
 
-Schema::Schema(const std::string &db_arg) :
-  db(db_arg)
+Schema::Schema(str_ref db_arg) :
+  db(db_arg.data(), db_arg.size())
 { 
 #if 0
   string::size_type lastPos= db.find_first_of('/', 0);
@@ -78,56 +78,19 @@
 
 bool Schema::isValid() const
 {
-  bool error= false;
-
-  do
-  {
-    if (db.empty())
-    {
-      error= true;
-      break;
-    }
-
-    if (db.size() > NAME_LEN)
-    {
-      error= true;
-      break;
-    }
-
-    if (db.at(db.length() -1) == ' ')
-    {
-      error= true;
-      break;
-    }
-
-    if (db.at(0) == '.')
-    {
-      error= true;
-      break;
-    }
-
-    {
-      const charset_info_st * const cs= &my_charset_utf8mb4_general_ci;
-
-      int well_formed_error;
-      uint32_t res= cs->cset->well_formed_len(cs, db.c_str(), db.c_str() + db.length(),
-                                              NAME_CHAR_LEN, &well_formed_error);
-      if (well_formed_error or db.length() != res)
-      {
-        error= true;
-        break;
-      }
-    }
-  } while (0);
-
-  if (error)
-  {
-    my_error(ER_WRONG_DB_NAME, *this);
-
-    return false;
+  const charset_info_st& cs= my_charset_utf8mb4_general_ci;
+  int well_formed_error;
+  if (not db.empty()
+    && db.size() <= NAME_LEN
+    && db.at(0) != '.'
+    && db.at(db.size() - 1) != ' '
+    && db.size() == cs.cset->well_formed_len(&cs, db.c_str(), db.c_str() + db.length(), NAME_CHAR_LEN, &well_formed_error))
+  {
+    if (not well_formed_error)
+      return true;
   }
-
-  return true;
+  my_error(ER_WRONG_DB_NAME, *this);
+  return false;
 }
 
 const std::string &Schema::getCatalogName() const

=== modified file 'drizzled/identifier/schema.h'
--- drizzled/identifier/schema.h	2011-03-28 17:55:27 +0000
+++ drizzled/identifier/schema.h	2011-10-18 13:52:19 +0000
@@ -43,7 +43,7 @@
   std::string db_path;
 
 public:
-  Schema(const std::string &db_arg);
+  Schema(str_ref);
 
   virtual std::string getSQLPath() const
 	{
@@ -74,14 +74,13 @@
     return boost::ilexicographical_compare(left.getSchemaName(), right.getSchemaName());
   }
 
-  friend bool operator==(const Schema& left,
-                         const Schema& right)
+  friend bool operator==(const Schema& left, const Schema& right)
   {
     return boost::iequals(left.getSchemaName(), right.getSchemaName());
   }
 };
 
-std::ostream& operator<<(std::ostream& output, const Schema&identifier);
+std::ostream& operator<<(std::ostream&, const Schema&);
 
 
 } /* namespace identifier */

=== modified file 'drizzled/identifier/table.cc'
--- drizzled/identifier/table.cc	2011-07-07 13:28:01 +0000
+++ drizzled/identifier/table.cc	2011-10-18 13:52:19 +0000
@@ -184,7 +184,7 @@
 }
 
 Table::Table(const drizzled::Table &table) :
-  identifier::Schema(table.getShare()->getSchemaName()),
+  identifier::Schema(str_ref(table.getShare()->getSchemaName())),
   type(table.getShare()->getTableType()),
   table_name(table.getShare()->getTableName())
 {

=== modified file 'drizzled/key.h'
--- drizzled/key.h	2011-10-06 20:27:18 +0000
+++ drizzled/key.h	2011-10-17 23:59:40 +0000
@@ -32,19 +32,17 @@
 
 namespace drizzled {
 
-class Key :public memory::SqlAlloc {
+class Key : public memory::SqlAlloc 
+{
 public:
-  enum Keytype { PRIMARY, UNIQUE, MULTIPLE, FOREIGN_KEY};
+  enum Keytype { PRIMARY, UNIQUE, MULTIPLE, FOREIGN_KEY };
   Keytype type;
   KEY_CREATE_INFO key_create_info;
   List<Key_part_spec> columns;
   lex_string_t name;
   bool generated;
 
-  Key(Keytype type_par,
-      const lex_string_t &name_arg,
-      KEY_CREATE_INFO *key_info_arg,
-      bool generated_arg, List<Key_part_spec> &cols) :
+  Key(Keytype type_par, lex_string_t name_arg, KEY_CREATE_INFO *key_info_arg, bool generated_arg, List<Key_part_spec> &cols) :
     type(type_par),
     key_create_info(*key_info_arg),
     columns(cols),
@@ -52,12 +50,7 @@
     generated(generated_arg)
   {}
 
-  Key(Keytype type_par,
-      const char *name_arg,
-      size_t name_len_arg,
-      KEY_CREATE_INFO *key_info_arg,
-      bool generated_arg,
-      List<Key_part_spec> &cols) :
+  Key(Keytype type_par, const char *name_arg, size_t name_len_arg, KEY_CREATE_INFO *key_info_arg, bool generated_arg, List<Key_part_spec> &cols) :
     type(type_par),
     key_create_info(*key_info_arg),
     columns(cols),
@@ -72,8 +65,7 @@
 };
 
 
-int find_ref_key(KeyInfo *key, uint32_t key_count, unsigned char *record, Field *field,
-                 uint32_t *key_length, uint32_t *keypart);
+int find_ref_key(KeyInfo *key, uint32_t key_count, unsigned char *record, Field *field, uint32_t *key_length, uint32_t *keypart);
 /**
   Copy part of a record that forms a key or key prefix to a buffer.
 
@@ -90,10 +82,8 @@
 */
 
 DRIZZLED_API void key_copy(unsigned char *to_key, unsigned char *from_record, KeyInfo *key_info, uint32_t key_length);
-void key_copy(std::basic_string<unsigned char> &to_key,
-              unsigned char *from_record, KeyInfo *key_info, uint32_t key_length);
-void key_restore(unsigned char *to_record, unsigned char *from_key, KeyInfo *key_info,
-                 uint16_t key_length);
+void key_copy(std::basic_string<unsigned char> &to_key, unsigned char *from_record, KeyInfo *key_info, uint32_t key_length);
+void key_restore(unsigned char *to_record, unsigned char *from_key, KeyInfo *key_info, uint16_t key_length);
 void key_zero_nulls(unsigned char *tuple, KeyInfo *key_info);
 bool key_cmp_if_same(Table *form,const unsigned char *key,uint32_t index,uint32_t key_length);
 void key_unpack(String *to, const Table *form,uint32_t index);
@@ -101,4 +91,3 @@
 int key_cmp(KeyPartInfo *key_part, const unsigned char *key, uint32_t key_length);
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/key_part_spec.h'
--- drizzled/key_part_spec.h	2011-10-06 18:18:31 +0000
+++ drizzled/key_part_spec.h	2011-10-18 12:15:09 +0000
@@ -25,11 +25,12 @@
 
 namespace drizzled {
 
-class Key_part_spec :public memory::SqlAlloc {
+class Key_part_spec : public memory::SqlAlloc 
+{
 public:
-  lex_string_t field_name;
+  str_ref field_name;
   uint32_t length;
-  Key_part_spec(const lex_string_t &name, uint32_t len)
+  Key_part_spec(str_ref name, uint32_t len)
     : field_name(name), length(len)
   {}
   Key_part_spec(const char *name, const size_t name_len, uint32_t len)

=== modified file 'drizzled/lex_input_stream.h'
--- drizzled/lex_input_stream.h	2011-08-08 12:51:19 +0000
+++ drizzled/lex_input_stream.h	2011-10-18 12:33:04 +0000
@@ -267,8 +267,7 @@
 
   void body_utf8_append(const char *ptr);
   void body_utf8_append(const char *ptr, const char *end_ptr);
-  void body_utf8_append_literal(const lex_string_t *txt,
-                                const char *end_ptr);
+  void body_utf8_append_literal(str_ref txt, const char *end_ptr);
 
   /** Current thread. */
   Session *m_session;

=== modified file 'drizzled/lex_string.h'
--- drizzled/lex_string.h	2011-10-14 10:07:18 +0000
+++ drizzled/lex_string.h	2011-10-18 11:01:40 +0000
@@ -20,6 +20,7 @@
 #pragma once
 
 #include <cstddef>
+#include <drizzled/util/data_ref.h>
 
 namespace drizzled {
 
@@ -56,6 +57,11 @@
     length_ = s;
   }
 
+  void operator=(str_ref v)
+  {
+    assign(v.data(), v.size());
+  }
+
   char* str_;
   size_t length_;
 };

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-10-17 21:39:27 +0000
+++ drizzled/parser.cc	2011-10-18 12:33:04 +0000
@@ -221,11 +221,11 @@
   my_printf_error(ER_PARSE_ERROR_UNKNOWN, ER(ER_PARSE_ERROR_UNKNOWN), MYF(0), message);
 }
 
-bool check_reserved_words(lex_string_t *name)
+bool check_reserved_words(str_ref name)
 {
-  if (!my_strcasecmp(system_charset_info, name->data(), "GLOBAL") ||
-      !my_strcasecmp(system_charset_info, name->data(), "LOCAL") ||
-      !my_strcasecmp(system_charset_info, name->data(), "SESSION"))
+  if (!my_strcasecmp(system_charset_info, name.data(), "GLOBAL") ||
+      !my_strcasecmp(system_charset_info, name.data(), "LOCAL") ||
+      !my_strcasecmp(system_charset_info, name.data(), "SESSION"))
     return true;
 
   return false;
@@ -441,16 +441,10 @@
 void buildForeignKey(LEX *lex, const lex_string_t &name_arg, drizzled::Table_ident *table)
 {
   statement::AlterTable *statement= (statement::AlterTable *)lex->statement;
-  Key *key= new Foreign_key(name_arg, lex->col_list,
-                            table,
-                            lex->ref_list,
-                            statement->fk_delete_opt,
-                            statement->fk_update_opt,
-                            statement->fk_match_option);
+  statement->alter_info.key_list.push_back(new Foreign_key(name_arg, lex->col_list, table, lex->ref_list, 
+    statement->fk_delete_opt, statement->fk_update_opt, statement->fk_match_option));
 
-  statement->alter_info.key_list.push_back(key);
-  key= new Key(Key::MULTIPLE, name_arg, &default_key_create_info, 1, lex->col_list);
-  statement->alter_info.key_list.push_back(key);
+  statement->alter_info.key_list.push_back(new Key(Key::MULTIPLE, name_arg, &default_key_create_info, 1, lex->col_list));
   lex->col_list.clear(); /* Alloced by memory::sql_alloc */
   /* Only used for ALTER TABLE. Ignored otherwise. */
   statement->alter_info.flags.set(ALTER_FOREIGN_KEY);

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-10-17 21:39:27 +0000
+++ drizzled/parser.h	2011-10-18 12:33:04 +0000
@@ -110,53 +110,53 @@
 namespace drizzled {
 namespace parser {
 
-Item* handle_sql2003_note184_exception(Session *session, Item* left, bool equal, Item *expr);
-bool add_select_to_union_list(Session *session, LEX *lex, bool is_union_distinct);
-bool setup_select_in_parentheses(Session *session, LEX *lex);
-Item* reserved_keyword_function(Session *session, const std::string &name, List<Item> *item_list);
-void my_parse_error(Lex_input_stream *lip);
-void my_parse_error(const char *message);
-bool check_reserved_words(lex_string_t *name);
-void errorOn(drizzled::Session *session, const char *s);
-
-
-bool buildOrderBy(LEX *lex);
-void buildEngineOption(LEX *lex, const char *key, str_ref value);
-void buildEngineOption(LEX *lex, const char *key, uint64_t value);
-void buildSchemaOption(LEX *lex, const char *key, str_ref value);
-void buildSchemaOption(LEX *lex, const char *key, uint64_t value);
-void buildSchemaDefiner(LEX *lex, const lex_string_t &value);
-void buildSchemaDefiner(LEX *lex, const identifier::User &user);
-bool checkFieldIdent(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name);
-
-Item *buildIdent(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name);
-Item *buildTableWild(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name);
-
-void buildCreateFieldIdent(LEX *lex);
-
-void storeAlterColumnPosition(LEX *lex, const char *position);
-
-bool buildCollation(LEX *lex, const charset_info_st *arg);
-void buildKey(LEX *lex, Key::Keytype type_par, const lex_string_t &name_arg);
-void buildForeignKey(LEX *lex, const lex_string_t &name_arg, drizzled::Table_ident *table);
-
-drizzled::enum_field_types buildIntegerColumn(LEX *lex, drizzled::enum_field_types final_type, const bool is_unsigned);
-drizzled::enum_field_types buildSerialColumn(LEX *lex);
-drizzled::enum_field_types buildVarcharColumn(LEX *lex, const char *length);
-drizzled::enum_field_types buildVarbinaryColumn(LEX *lex, const char *length);
-drizzled::enum_field_types buildBlobColumn(LEX *lex);
-drizzled::enum_field_types buildBooleanColumn(LEX *lex);
-drizzled::enum_field_types buildUuidColumn(LEX *lex);
-drizzled::enum_field_types buildIPv6Column(LEX *lex);
-drizzled::enum_field_types buildDoubleColumn(LEX *lex);
-drizzled::enum_field_types buildTimestampColumn(LEX *lex, const char *length);
-drizzled::enum_field_types buildDecimalColumn(LEX *lex);
-
-void buildKeyOnColumn(LEX *lex);
-void buildAutoOnColumn(LEX *lex);
-void buildPrimaryOnColumn(LEX *lex);
-void buildReplicationOption(LEX *lex, bool arg);
-void buildAddAlterDropIndex(LEX *lex, const char *name, bool is_foreign_key= false);
+Item* handle_sql2003_note184_exception(Session*, Item* left, bool equal, Item *expr);
+bool add_select_to_union_list(Session*, LEX*, bool is_union_distinct);
+bool setup_select_in_parentheses(Session*, LEX*);
+Item* reserved_keyword_function(Session*, const std::string &name, List<Item> *item_list);
+void my_parse_error(Lex_input_stream*);
+void my_parse_error(const char*);
+bool check_reserved_words(str_ref);
+void errorOn(drizzled::Session*, const char *s);
+
+
+bool buildOrderBy(LEX*);
+void buildEngineOption(LEX*, const char *key, str_ref value);
+void buildEngineOption(LEX*, const char *key, uint64_t value);
+void buildSchemaOption(LEX*, const char *key, str_ref value);
+void buildSchemaOption(LEX*, const char *key, uint64_t value);
+void buildSchemaDefiner(LEX*, const lex_string_t &value);
+void buildSchemaDefiner(LEX*, const identifier::User &user);
+bool checkFieldIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
+
+Item *buildIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name);
+Item *buildTableWild(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
+
+void buildCreateFieldIdent(LEX*);
+
+void storeAlterColumnPosition(LEX*, const char *position);
+
+bool buildCollation(LEX*, const charset_info_st *arg);
+void buildKey(LEX*, Key::Keytype type_par, const lex_string_t &name_arg);
+void buildForeignKey(LEX*, const lex_string_t &name_arg, drizzled::Table_ident *table);
+
+drizzled::enum_field_types buildIntegerColumn(LEX*, drizzled::enum_field_types final_type, const bool is_unsigned);
+drizzled::enum_field_types buildSerialColumn(LEX*);
+drizzled::enum_field_types buildVarcharColumn(LEX*, const char *length);
+drizzled::enum_field_types buildVarbinaryColumn(LEX*, const char *length);
+drizzled::enum_field_types buildBlobColumn(LEX*);
+drizzled::enum_field_types buildBooleanColumn(LEX*);
+drizzled::enum_field_types buildUuidColumn(LEX*);
+drizzled::enum_field_types buildIPv6Column(LEX*);
+drizzled::enum_field_types buildDoubleColumn(LEX*);
+drizzled::enum_field_types buildTimestampColumn(LEX*, const char *length);
+drizzled::enum_field_types buildDecimalColumn(LEX*);
+
+void buildKeyOnColumn(LEX*);
+void buildAutoOnColumn(LEX*);
+void buildPrimaryOnColumn(LEX*);
+void buildReplicationOption(LEX*, bool arg);
+void buildAddAlterDropIndex(LEX*, const char *name, bool is_foreign_key= false);
 
 } // namespace parser
 } // namespace drizzled

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-10-14 10:40:47 +0000
+++ drizzled/session.cc	2011-10-18 11:48:44 +0000
@@ -419,10 +419,7 @@
     assert(security_ctx);
     if (global_system_variables.log_warnings)
     {
-      errmsg_printf(error::WARN, ER(ER_FORCING_CLOSE),
-                    internal::my_progname,
-                    thread_id,
-                    security_ctx->username().c_str());
+      errmsg_printf(error::WARN, ER(ER_FORCING_CLOSE), internal::my_progname, thread_id, security_ctx->username().c_str());
     }
 
     disconnect();
@@ -1686,16 +1683,12 @@
   current_global_counters.connections= 0;
 }
 
-user_var_entry *Session::getVariable(lex_string_t &name, bool create_if_not_exists)
-{
-  return getVariable(to_string(name), create_if_not_exists);
-}
-
-user_var_entry *Session::getVariable(const std::string  &name, bool create_if_not_exists)
+user_var_entry* Session::getVariable(str_ref name0, bool create_if_not_exists)
 {
   if (cleanup_done)
     return NULL;
 
+  string name(name0.data(), name0.size());
   if (UserVars::mapped_type* iter= find_ptr(user_vars, name))
     return *iter;
 
@@ -1716,14 +1709,9 @@
 
 void Session::setVariable(const std::string &name, const std::string &value)
 {
-  user_var_entry *updateable_var= getVariable(name.c_str(), true);
-  if (updateable_var)
+  if (user_var_entry* var= getVariable(name, true))
   {
-    updateable_var->update_hash(false,
-                                (void*)value.c_str(),
-                                static_cast<uint32_t>(value.length()), STRING_RESULT,
-                                &my_charset_bin,
-                                DERIVATION_IMPLICIT, false);
+    var->update_hash(false, value, STRING_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, false);
   }
 }
 

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-10-14 10:40:47 +0000
+++ drizzled/session.h	2011-10-18 11:01:40 +0000
@@ -1021,18 +1021,16 @@
   void add_group_to_list(Item *item, bool asc);
 
   void refresh_status();
-  user_var_entry *getVariable(lex_string_t &name, bool create_if_not_exists);
-  user_var_entry *getVariable(const std::string  &name, bool create_if_not_exists);
-  void setVariable(const std::string &name, const std::string &value);
+  user_var_entry* getVariable(str_ref name, bool create_if_not_exists);
+  void setVariable(const std::string& name, const std::string& value);
 
   /**
    * Closes all tables used by the current substatement, or all tables
    * used by this thread if we are on the upper level.
    */
   void close_thread_tables();
-  void close_old_data_files(bool morph_locks= false,
-                            bool send_refresh= false);
-  void close_data_files_and_morph_locks(const identifier::Table &identifier);
+  void close_old_data_files(bool morph_locks= false, bool send_refresh= false);
+  void close_data_files_and_morph_locks(const identifier::Table&);
 
   /**
    * Prepares statement for reopening of tables and recalculation of set of

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2011-10-17 22:46:16 +0000
+++ drizzled/show.cc	2011-10-18 13:52:19 +0000
@@ -174,9 +174,9 @@
   util::string::ptr schema(session->schema());
   if (ident)
   {
-    identifier::Schema identifier(ident);
+    identifier::Schema identifier= str_ref(ident);
     column_name.append(ident);
-    session->lex().select_lex.db= const_cast<char *>(ident);
+    session->lex().select_lex.db= ident;
     if (not plugin::StorageEngine::doesSchemaExist(identifier))
     {
       my_error(ER_BAD_DB_ERROR, identifier);
@@ -240,7 +240,7 @@
   {
     session->lex().select_lex.db= const_cast<char *>(ident);
 
-    identifier::Schema identifier(ident);
+    identifier::Schema identifier= str_ref(ident);
     if (not plugin::StorageEngine::doesSchemaExist(identifier))
     {
       my_error(ER_BAD_DB_ERROR, identifier);

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2011-08-03 10:04:55 +0000
+++ drizzled/sql_base.h	2011-10-18 11:01:40 +0000
@@ -42,7 +42,7 @@
                        uint32_t type_modifier,
                        enum column_format_type column_format,
                        Item *default_value, Item *on_update_value,
-                       lex_string_t *comment,
+                       str_ref comment,
                        const char *change, List<String> *interval_list,
                        const charset_info_st * const cs);
 CreateField * new_create_field(Session *session, const char *field_name, enum_field_types type,

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2011-10-14 10:07:18 +0000
+++ drizzled/sql_lex.cc	2011-10-18 12:33:04 +0000
@@ -161,16 +161,15 @@
                   m_cpp_utf8_processed_ptr will be set in the end of the
                   operation.
 */
-void Lex_input_stream::body_utf8_append_literal(const lex_string_t *txt,
-                                                const char *end_ptr)
+void Lex_input_stream::body_utf8_append_literal(str_ref txt, const char *end_ptr)
 {
   if (!m_cpp_utf8_processed_ptr)
     return;
 
   /* NOTE: utf_txt.length is in bytes, not in symbols. */
 
-  memcpy(m_body_utf8_ptr, txt->data(), txt->size());
-  m_body_utf8_ptr += txt->size();
+  memcpy(m_body_utf8_ptr, txt.data(), txt.size());
+  m_body_utf8_ptr += txt.size();
   *m_body_utf8_ptr= 0;
 
   m_cpp_utf8_processed_ptr= end_ptr;
@@ -756,7 +755,7 @@
 
       lip->body_utf8_append(lip->m_cpp_text_start);
 
-      lip->body_utf8_append_literal(&yylval->lex_str, lip->m_cpp_text_end);
+      lip->body_utf8_append_literal(yylval->lex_str, lip->m_cpp_text_end);
 
       return(result_state);			// IDENT or IDENT_QUOTED
 
@@ -853,7 +852,7 @@
 
       lip->body_utf8_append(lip->m_cpp_text_start);
 
-      lip->body_utf8_append_literal(&yylval->lex_str, lip->m_cpp_text_end);
+      lip->body_utf8_append_literal(yylval->lex_str, lip->m_cpp_text_end);
 
       return(result_state);
 
@@ -879,16 +878,15 @@
           break;				// Error
         lip->skip_binary(var_length-1);
       }
-      if (double_quotes)
-	      yylval->lex_str=get_quoted_token(lip, 1, lip->yyLength() - double_quotes -1, quote_char);
-      else
-        yylval->lex_str=get_token(lip, 1, lip->yyLength() -1);
+      yylval->lex_str= double_quotes
+        ? get_quoted_token(lip, 1, lip->yyLength() - double_quotes - 1, quote_char)
+        : get_token(lip, 1, lip->yyLength() - 1);
       if (c == quote_char)
         lip->yySkip();                  // Skip end `
       lip->next_state= MY_LEX_START;
       lip->body_utf8_append(lip->m_cpp_text_start);
-      lip->body_utf8_append_literal(&yylval->lex_str, lip->m_cpp_text_end);
-      return(IDENT_QUOTED);
+      lip->body_utf8_append_literal(yylval->lex_str, lip->m_cpp_text_end);
+      return IDENT_QUOTED;
     }
     case MY_LEX_INT_OR_REAL:		// Complete int or incomplete real
       if (c != '.')
@@ -998,7 +996,7 @@
       yylval->lex_str.assign(yylval->lex_str.data(), lip->yytoklen);
 
       lip->body_utf8_append(lip->m_cpp_text_start);
-      lip->body_utf8_append_literal(&yylval->lex_str, lip->m_cpp_text_end);
+      lip->body_utf8_append_literal(yylval->lex_str, lip->m_cpp_text_end);
 
       lex->text_string_is_7bit= (lip->tok_bitmap & 0x80) ? 0 : 1;
       return(TEXT_STRING);
@@ -1233,10 +1231,9 @@
       yylval->lex_str=get_token(lip, 0, length);
 
       lip->body_utf8_append(lip->m_cpp_text_start);
-
-      lip->body_utf8_append_literal(&yylval->lex_str, lip->m_cpp_text_end);
-
-      return(result_state);
+      lip->body_utf8_append_literal(yylval->lex_str, lip->m_cpp_text_end);
+
+      return result_state;
     }
   }
 }

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2011-08-14 12:20:36 +0000
+++ drizzled/sql_load.cc	2011-10-18 11:01:40 +0000
@@ -639,8 +639,7 @@
       }
       else if (item->type() == Item::STRING_ITEM)
       {
-        ((Item_user_var_as_out_param *)item)->set_value((char*) pos, length,
-                                                        read_info.read_charset);
+        ((Item_user_var_as_out_param *)item)->set_value(str_ref((char*) pos, length), read_info.read_charset);
       }
       else
       {

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-10-17 21:54:16 +0000
+++ drizzled/sql_parse.cc	2011-10-18 13:52:19 +0000
@@ -796,7 +796,7 @@
 bool add_field_to_list(Session *session, lex_string_t *field_name, enum_field_types type,
 		       const char *length, const char *decimals,
 		       uint32_t type_modifier, column_format_type column_format,
-		       Item *default_value, Item *on_update_value, lex_string_t *comment,
+		       Item *default_value, Item *on_update_value, str_ref comment,
 		       const char *change, List<String> *interval_list, const charset_info_st* cs)
 {
   LEX  *lex= &session->lex();
@@ -857,7 +857,7 @@
   }
 
   CreateField* new_field= new CreateField;
-  if (new_field->init(session, field_name->data(), type, length, decimals, type_modifier, *comment, change, interval_list, cs, 0, column_format)
+  if (new_field->init(session, field_name->data(), type, length, decimals, type_modifier, comment, change, interval_list, cs, 0, column_format)
       || new_field->setDefaultValue(default_value, on_update_value))
     return true;
 
@@ -911,7 +911,7 @@
   if (not table->is_derived_table() && table->db.data())
   {
     my_casedn_str(files_charset_info, table->db.str_);
-    if (not schema::check(*session, identifier::Schema(table->db.data())))
+    if (not schema::check(*session, identifier::Schema(table->db)))
     {
       my_error(ER_WRONG_DB_NAME, MYF(0), table->db.data());
       return NULL;
@@ -1549,23 +1549,23 @@
 */
 
 
-bool check_string_char_length(lex_string_t *str, const char *err_msg,
+bool check_string_char_length(str_ref str, const char *err_msg,
                               uint32_t max_char_length, const charset_info_st * const cs,
                               bool no_error)
 {
   int well_formed_error;
-  uint32_t res= cs->cset->well_formed_len(cs, str->begin(), str->end(), max_char_length, &well_formed_error);
+  uint32_t res= cs->cset->well_formed_len(cs, str.begin(), str.end(), max_char_length, &well_formed_error);
 
-  if (!well_formed_error &&  str->size() == res)
+  if (!well_formed_error &&  str.size() == res)
     return false;
 
   if (!no_error)
-    my_error(ER_WRONG_STRING_LENGTH, MYF(0), str->data(), err_msg, max_char_length);
+    my_error(ER_WRONG_STRING_LENGTH, MYF(0), str.data(), err_msg, max_char_length);
   return true;
 }
 
 
-bool check_identifier_name(lex_string_t str, error_t err_code)
+bool check_identifier_name(str_ref str, error_t err_code)
 {
   uint32_t max_char_length= NAME_CHAR_LEN;
   /*

=== modified file 'drizzled/sql_parse.h'
--- drizzled/sql_parse.h	2011-10-17 21:54:16 +0000
+++ drizzled/sql_parse.h	2011-10-17 23:13:25 +0000
@@ -23,7 +23,6 @@
 
 #include <drizzled/definitions.h>
 #include <drizzled/common.h>
-#include <drizzled/lex_string.h>
 #include <drizzled/comp_creator.h>
 #include <drizzled/identifier.h>
 
@@ -32,41 +31,35 @@
 
 namespace drizzled {
 
-DRIZZLED_API const std::string &getCommandName(const enum_server_command& command);
-
-bool execute_sqlcom_select(Session *session, TableList *all_tables);
-bool insert_select_prepare(Session *session);
-bool update_precheck(Session *session, TableList *tables);
-bool delete_precheck(Session *session, TableList *tables);
-bool insert_precheck(Session *session, TableList *tables);
-
-Item *negate_expression(Session *session, Item *expr);
-
-bool check_identifier_name(lex_string_t str, error_t err_code= EE_OK);
-
-bool check_string_byte_length(lex_string_t *str, const char *err_msg,
-                              uint32_t max_byte_length);
-bool check_string_char_length(lex_string_t *str, const char *err_msg,
-                              uint32_t max_char_length, const charset_info_st * const cs,
-                              bool no_error);
-
-
-bool test_parse_for_slave(Session *session, char *inBuf,
-                                uint32_t length);
-
-void reset_session_for_next_command(Session *session);
-
-void create_select_for_variable(Session *session, const char *var_name);
-
-void init_update_queries(void);
-
-bool dispatch_command(enum enum_server_command command, Session* session,
-                      const char* packet, uint32_t packet_length);
-
-bool check_simple_select(Session* session);
-
-void init_select(LEX *lex);
-bool new_select(LEX *lex, bool move_down);
+DRIZZLED_API const std::string& getCommandName(const enum_server_command& command);
+
+bool execute_sqlcom_select(Session*, TableList *all_tables);
+bool insert_select_prepare(Session*);
+bool update_precheck(Session*, TableList *tables);
+bool delete_precheck(Session*, TableList *tables);
+bool insert_precheck(Session*, TableList *tables);
+
+Item *negate_expression(Session*, Item *expr);
+
+bool check_identifier_name(str_ref, error_t err_code= EE_OK);
+
+bool check_string_byte_length(str_ref, const char *err_msg, uint32_t max_byte_length);
+bool check_string_char_length(str_ref, const char *err_msg, uint32_t max_char_length, const charset_info_st*, bool no_error);
+
+bool test_parse_for_slave(Session*, char *inBuf, uint32_t length);
+
+void reset_session_for_next_command(Session*);
+
+void create_select_for_variable(Session*, const char *var_name);
+
+void init_update_queries();
+
+bool dispatch_command(enum_server_command command, Session*, const char* packet, uint32_t packet_length);
+
+bool check_simple_select(Session*);
+
+void init_select(LEX*);
+bool new_select(LEX*, bool move_down);
 
 int prepare_new_schema_table(Session*, LEX&, const std::string& schema_table_name);
 
@@ -75,7 +68,7 @@
                                 bool all,
                                 Select_Lex *select_lex);
 
-char* query_table_status(Session *session,const char *db,const char *table_name);
+char* query_table_status(Session*,const char *db,const char *table_name);
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-10-16 17:36:34 +0000
+++ drizzled/sql_table.cc	2011-10-18 13:52:19 +0000
@@ -73,7 +73,7 @@
     apply it to the table.
   */
   if (not create_info->default_table_charset)
-    create_info->default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier::Schema(db));
+    create_info->default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier::Schema(str_ref(db)));
 }
 
 /*

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-10-17 22:46:16 +0000
+++ drizzled/sql_yacc.yy	2011-10-18 12:33:04 +0000
@@ -1238,7 +1238,7 @@
                                   Lex.length, Lex.dec, Lex.type,
                                   statement->column_format,
                                   statement->default_value, statement->on_update_value,
-                                  &statement->comment,
+                                  statement->comment,
                                   statement->change, &Lex.interval_list, Lex.charset))
               DRIZZLE_YYABORT;
 
@@ -1943,7 +1943,7 @@
                                   statement->column_format,
                                   statement->default_value,
                                   statement->on_update_value,
-                                  &statement->comment,
+                                  statement->comment,
                                   $3.data(), &Lex.interval_list, Lex.charset))
               DRIZZLE_YYABORT;
           }
@@ -3241,7 +3241,7 @@
         | '@' opt_var_ident_type user_variable_ident opt_component
           {
             /* disallow "SELECT @@global.global.variable" */
-            if ($3.data() && $4.data() && parser::check_reserved_words(&$3))
+            if ($3.data() && $4.data() && parser::check_reserved_words($3))
             {
               parser::my_parse_error(YYSession->m_lip);
               DRIZZLE_YYABORT;

=== modified file 'drizzled/statement/alter_schema.cc'
--- drizzled/statement/alter_schema.cc	2011-10-10 12:58:39 +0000
+++ drizzled/statement/alter_schema.cc	2011-10-18 13:52:19 +0000
@@ -31,28 +31,24 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 bool statement::AlterSchema::execute()
 {
-  lex_string_t *db= &lex().name;
-  message::schema::shared_ptr old_definition;
-
   if (not validateSchemaOptions())
     return true;
 
-  identifier::Schema schema_identifier(string(db->data(), db->size()));
+  identifier::Schema schema_identifier(lex().name);
 
   if (not schema::check(session(), schema_identifier))
   {
     my_error(ER_WRONG_DB_NAME, schema_identifier);
-
     return false;
   }
 
-  identifier::Schema identifier(db->data());
-  if (not (old_definition= plugin::StorageEngine::getSchemaDefinition(identifier)))
+  identifier::Schema identifier(lex().name);
+  message::schema::shared_ptr old_definition= plugin::StorageEngine::getSchemaDefinition(identifier);
+  if (not old_definition)
   {
     my_error(ER_SCHEMA_DOES_NOT_EXIST, identifier); 
     return true;
@@ -88,4 +84,3 @@
 }
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2011-10-14 10:07:18 +0000
+++ drizzled/statement/alter_table.cc	2011-10-17 23:43:57 +0000
@@ -466,12 +466,12 @@
   KeyInfo *key_info= table->key_info;
   for (uint32_t i= 0; i < table->getShare()->sizeKeys(); i++, key_info++)
   {
-    char *key_name= key_info->name;
+    const char *key_name= key_info->name;
 
     vector<string>::iterator it= drop_keys.begin();
     while (it != drop_keys.end())
     {
-      if (not my_strcasecmp(system_charset_info, key_name, (*it).c_str()))
+      if (not my_strcasecmp(system_charset_info, key_name, it->c_str()))
         break;
       it++;
     }
@@ -542,15 +542,9 @@
       if (key_info->flags & HA_USES_COMMENT)
         key_create_info.comment= key_info->comment;
 
-      Key::Keytype key_type;
-      if (key_info->flags & HA_NOSAME)
-      {
-        key_type= is_primary_key(key_name) ? Key::PRIMARY : Key::UNIQUE;
-      }
-      else
-      {
-        key_type= Key::MULTIPLE;
-      }
+      Key::Keytype key_type= key_info->flags & HA_NOSAME
+        ? (is_primary_key(key_name) ? Key::PRIMARY : Key::UNIQUE)
+        : Key::MULTIPLE;
       new_key_list.push_back(new Key(key_type, key_name, strlen(key_name), &key_create_info, test(key_info->flags & HA_GENERATED_KEY), key_parts));
     }
   }

=== modified file 'drizzled/statement/change_schema.cc'
--- drizzled/statement/change_schema.cc	2011-03-15 21:30:35 +0000
+++ drizzled/statement/change_schema.cc	2011-10-18 13:52:19 +0000
@@ -33,9 +33,7 @@
 
 bool statement::ChangeSchema::execute()
 {
-  Select_Lex *select_lex= &lex().select_lex;
-
-  identifier::Schema identifier(select_lex->db);
+  identifier::Schema identifier(str_ref(lex().select_lex.db));
   if (not schema::change(session(), identifier))
   {
     session().my_ok();

=== modified file 'drizzled/statement/create_table.h'
--- drizzled/statement/create_table.h	2011-10-14 10:56:52 +0000
+++ drizzled/statement/create_table.h	2011-10-18 11:01:40 +0000
@@ -85,7 +85,7 @@
   column_format_type column_format;
 
   /* Poly-use */
-  lex_string_t comment;
+  str_ref comment;
 
   bool is_engine_set;
   bool is_create_table_like;

=== modified file 'drizzled/statement/release_savepoint.h'
--- drizzled/statement/release_savepoint.h	2011-08-03 10:04:55 +0000
+++ drizzled/statement/release_savepoint.h	2011-10-18 11:01:40 +0000
@@ -29,7 +29,7 @@
 class ReleaseSavepoint : public Statement
 {
 public:
-  ReleaseSavepoint(Session *in_session, const lex_string_t &ident) :
+  ReleaseSavepoint(Session *in_session, str_ref ident) :
     Statement(in_session)
   {
     set_command(SQLCOM_RELEASE_SAVEPOINT);

=== modified file 'drizzled/statement/rollback_to_savepoint.h'
--- drizzled/statement/rollback_to_savepoint.h	2011-08-03 10:04:55 +0000
+++ drizzled/statement/rollback_to_savepoint.h	2011-10-18 11:01:40 +0000
@@ -29,7 +29,7 @@
 class RollbackToSavepoint : public Statement
 {
 public:
-  RollbackToSavepoint(Session *in_session, const lex_string_t &ident) :
+  RollbackToSavepoint(Session *in_session, str_ref ident) :
     Statement(in_session)
   {
     set_command(SQLCOM_ROLLBACK_TO_SAVEPOINT);

=== modified file 'drizzled/statement/savepoint.h'
--- drizzled/statement/savepoint.h	2011-08-03 10:04:55 +0000
+++ drizzled/statement/savepoint.h	2011-10-18 11:01:40 +0000
@@ -29,7 +29,7 @@
 class Savepoint : public Statement
 {
 public:
-  Savepoint(Session *in_session, const lex_string_t &ident) :
+  Savepoint(Session *in_session, str_ref ident) :
     Statement(in_session)
   {
     set_command(SQLCOM_SAVEPOINT);

=== modified file 'drizzled/table/instance/base.cc'
--- drizzled/table/instance/base.cc	2011-10-10 10:13:51 +0000
+++ drizzled/table/instance/base.cc	2011-10-18 12:33:04 +0000
@@ -975,12 +975,8 @@
       unireg_type= Field::TIMESTAMP_UN_FIELD;
     }
 
-    lex_string_t comment;
-    if (!pfield.has_comment())
-    {
-      comment.assign("", 0);
-    }
-    else
+    str_ref comment;
+    if (pfield.has_comment())
     {
       comment.assign(mem().strdup(pfield.comment()), pfield.comment().size());
     }

=== modified file 'drizzled/user_var_entry.cc'
--- drizzled/user_var_entry.cc	2011-07-05 11:31:30 +0000
+++ drizzled/user_var_entry.cc	2011-10-18 11:48:44 +0000
@@ -184,9 +184,7 @@
     true    failure
 */
 
-void user_var_entry::update_hash(bool set_null, void *ptr, uint32_t arg_length,
-                                 Item_result arg_type, const charset_info_st * const cs, Derivation dv,
-                                 bool unsigned_arg)
+void user_var_entry::update_hash(bool set_null, data_ref data, Item_result arg_type, const charset_info_st* cs, Derivation dv, bool unsigned_arg)
 {
   if (set_null)
   {
@@ -201,7 +199,7 @@
   }
   else
   {
-    size_t needed_size= arg_length + ((arg_type == STRING_RESULT) ? 1 : 0);
+    size_t needed_size= data.size() + ((arg_type == STRING_RESULT) ? 1 : 0);
 
     if (needed_size > size)
     {
@@ -210,12 +208,12 @@
     }
 
     if (arg_type == STRING_RESULT)
-      value[arg_length]= 0;			// Store end \0
+      value[data.size()]= 0;			// Store end \0
 
-    memcpy(value, ptr, arg_length);
+    memcpy(value, data.data(), data.size());
     if (arg_type == DECIMAL_RESULT)
       ((type::Decimal*)value)->fix_buffer_pointer();
-    length= arg_length;
+    length= data.size();
     collation.set(cs, dv);
     unsigned_flag= unsigned_arg;
   }

=== modified file 'drizzled/user_var_entry.h'
--- drizzled/user_var_entry.h	2011-10-06 18:18:31 +0000
+++ drizzled/user_var_entry.h	2011-10-18 11:48:44 +0000
@@ -62,9 +62,7 @@
   type::Decimal *val_decimal(bool *null_value, type::Decimal *result);
   DTCollation collation;
 
-  void update_hash(bool set_null, void *ptr, uint32_t length,
-                   Item_result type, const charset_info_st * const cs, Derivation dv,
-                   bool unsigned_arg);
+  void update_hash(bool set_null, data_ref, Item_result type, const charset_info_st* cs, Derivation dv, bool unsigned_arg);
 };
 
 } /* namespace drizzled */

=== modified file 'drizzled/util/data_ref.h'
--- drizzled/util/data_ref.h	2011-10-14 09:23:40 +0000
+++ drizzled/util/data_ref.h	2011-10-18 11:48:44 +0000
@@ -107,8 +107,7 @@
 
 inline std::ostream& operator<<(std::ostream& os, str_ref v)
 {
-  os.write(v.data(), v.size());
-  return os;
+  return os.write(v.data(), v.size());
 }
 
 inline std::string to_string(str_ref v)

=== modified file 'drizzled/var.h'
--- drizzled/var.h	2011-07-25 14:24:19 +0000
+++ drizzled/var.h	2011-10-18 11:01:40 +0000
@@ -20,19 +20,18 @@
 
 #pragma once
 
-namespace drizzled
+namespace drizzled {
+
+class var : public memory::SqlAlloc  
 {
-
-class var : public memory::SqlAlloc  {
 public:
   lex_string_t s;
   bool local;
   uint32_t offset;
   enum_field_types type;
-  var (lex_string_t& j, bool i, uint32_t o, enum_field_types t)
-    :s(j), local(i), offset(o), type(t)
+  var(lex_string_t& j, bool i, uint32_t o, enum_field_types t) :
+    s(j), local(i), offset(o), type(t)
   {}
-  ~var() {}
 };
 
 } /* namespace drizzled */

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-08-16 11:47:29 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-10-18 13:52:19 +0000
@@ -6784,13 +6784,10 @@
 
 void InnobaseEngine::dropTemporarySchema()
 {
-  identifier::Schema schema_identifier(GLOBAL_TEMPORARY_EXT);
-  trx_t*  trx= NULL;
   string schema_path(GLOBAL_TEMPORARY_EXT);
-
-  schema_path.append("/");
-
-  trx = trx_allocate_for_mysql();
+  schema_path += "/";
+
+  trx_t* trx = trx_allocate_for_mysql();
 
   trx->mysql_thd = NULL;
 

=== modified file 'plugin/schema_engine/schema.cc'
--- plugin/schema_engine/schema.cc	2011-06-21 20:40:13 +0000
+++ plugin/schema_engine/schema.cc	2011-10-18 13:52:19 +0000
@@ -96,7 +96,7 @@
 {
   mutex.lock_shared();
   BOOST_FOREACH(SchemaCache::reference iter, schema_cache)
-    set_of_names.push_back(iter.second->name());
+    set_of_names.push_back(identifier::Schema(iter.second->name()));
   mutex.unlock_shared();
 }
 

=== modified file 'plugin/show_schema_proto/show_schema_proto.cc'
--- plugin/show_schema_proto/show_schema_proto.cc	2011-07-04 17:28:54 +0000
+++ plugin/show_schema_proto/show_schema_proto.cc	2011-10-18 13:52:19 +0000
@@ -40,15 +40,12 @@
 class ShowSchemaProtoFunction : public Item_str_func
 {
 public:
-  ShowSchemaProtoFunction() : Item_str_func() {}
   String *val_str(String*);
 
   void fix_length_and_dec()
   {
     max_length= 16384; /* Guesswork? */
-    args[0]->collation.set(
-      get_charset_by_csname(args[0]->collation.collation->csname,
-                            MY_CS_BINSORT), DERIVATION_COERCIBLE);
+    args[0]->collation.set(get_charset_by_csname(args[0]->collation.collation->csname, MY_CS_BINSORT), DERIVATION_COERCIBLE);
   }
 
   const char *func_name() const
@@ -69,7 +66,7 @@
 
   String *db_sptr= args[0]->val_str(str);
 
-  if (db_sptr == NULL)
+  if (not db_sptr)
   {
     null_value= true;
     return NULL;
@@ -77,19 +74,15 @@
 
   null_value= false;
 
-  const char* db= db_sptr->c_str();
-
-  string proto_as_text("");
-  message::schema::shared_ptr proto;
-
-
-  identifier::Schema schema_identifier(db);
-  if (not (proto= plugin::StorageEngine::getSchemaDefinition(schema_identifier)))
+  identifier::Schema schema_identifier(*db_sptr);
+  message::schema::shared_ptr proto= plugin::StorageEngine::getSchemaDefinition(schema_identifier);
+  if (not proto)
   {
     my_error(ER_BAD_DB_ERROR, schema_identifier);
     return NULL;
   }
 
+  string proto_as_text;
   protobuf::TextFormat::PrintToString(*proto, &proto_as_text);
 
   str->alloc(proto_as_text.length());

